import * as i0 from '@angular/core';
import { Injectable, Component, NgModule } from '@angular/core';
import { BehaviorSubject, of } from 'rxjs';

class D2fNgxCommonsService {
    constructor() { }
}
D2fNgxCommonsService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: D2fNgxCommonsService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
D2fNgxCommonsService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: D2fNgxCommonsService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: D2fNgxCommonsService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class D2fNgxCommonsComponent {
    constructor() { }
    ngOnInit() {
    }
}
D2fNgxCommonsComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: D2fNgxCommonsComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
D2fNgxCommonsComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.1.0", type: D2fNgxCommonsComponent, selector: "lib-d2f-ngx-commons", ngImport: i0, template: `
    <p>
      d2f-ngx-commons works!
    </p>
  `, isInline: true });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: D2fNgxCommonsComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-d2f-ngx-commons', template: `
    <p>
      d2f-ngx-commons works!
    </p>
  ` }]
        }], ctorParameters: function () { return []; } });

class D2fNgxCommonsModule {
}
D2fNgxCommonsModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: D2fNgxCommonsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
D2fNgxCommonsModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.1.0", ngImport: i0, type: D2fNgxCommonsModule, declarations: [D2fNgxCommonsComponent], exports: [D2fNgxCommonsComponent] });
D2fNgxCommonsModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: D2fNgxCommonsModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: D2fNgxCommonsModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        D2fNgxCommonsComponent
                    ],
                    imports: [],
                    exports: [
                        D2fNgxCommonsComponent
                    ]
                }]
        }] });

function messageFromError(err, myMsg /*: string*/ = "") {
    let message = "";
    if (err.error instanceof Error) {
        console.log("Client-side error occured." + JSON.stringify(err));
        message = myMsg;
    }
    else {
        console.log("Server-side error occured : " + JSON.stringify(err));
        let detailErrMsg = (err.error && err.error.message) ? ":" + err.error.message : "";
        message = myMsg + " (status=" + err.status + ":" + err.statusText + ") " + detailErrMsg;
    }
    return message;
}
function cloneObjectWithoutMethod(obj) {
    return JSON.parse(JSON.stringify(obj));
}
function copyObjectProperties(source, target) {
    let arrayOfPropKeys = Reflect.ownKeys(source);
    for (let key of arrayOfPropKeys) {
        Reflect.set(target, key, Reflect.get(source, key));
    }
}
function objectWithMethodsOfProto(objectWithoutMethods, protoWithMethods) {
    //!!! NB: protoWithMethods is modified here (should be as new created instance)!!!
    copyObjectProperties(objectWithoutMethods, protoWithMethods);
    return protoWithMethods; //modified with good data values
}

class UserSession {
    constructor(userId = "?" /* uuid or num or userName or ... */, userName = "?" /* to display : fullName or email or userId or ... */, userRoles = [], authToken = null /* null is not connected */, userDetails = null) {
        this.userId = userId;
        this.userName = userName;
        this.userRoles = userRoles;
        this.authToken = authToken;
        this.userDetails = userDetails;
    }
    hasRole(role) {
        return this.userRoles.includes(role);
    }
    isConnected() {
        return (this.authToken != null);
    }
    sumUp() {
        let sRes = (this.userName != "?") ? this.userName : this.userId;
        sRes += (this.isConnected()) ? " connected" : " not connected";
        sRes += (this.userRoles.length == 0) ? "" : " as " + this.userRoles.join(",");
        return sRes;
    }
    get userRolesAsString() {
        return this.userRoles.join(',');
    }
    set userRolesAsString(userRolesAsString) {
        if (userRolesAsString == null || userRolesAsString.length == 0)
            this.userRoles = [];
        else
            this.userRoles = userRolesAsString.split(',');
    }
}

/* user session in this angular frontEnd App */
class GenericUserSessionService {
    storeSessionKeyValue(key, value) {
        let sValue = "null";
        if (typeof value == 'string')
            sValue = value;
        else
            sValue = JSON.stringify(value);
        sessionStorage.setItem(key, sValue);
    }
    retreiveSessionValue(key, defaultValue) {
        let res = null;
        let sValue = sessionStorage.getItem(key);
        if (sValue != null && sValue != "null" && sValue != "") {
            try {
                res = JSON.parse(sValue);
            }
            catch (ex) {
                res = sValue;
            }
        }
        if (res == null) {
            res = defaultValue;
        }
        return res;
    }
}
class UserSessionService extends GenericUserSessionService {
    constructor() {
        super();
        this._bsUserSession$ = new BehaviorSubject(new UserSession());
        let userSession = objectWithMethodsOfProto(this.retreiveSessionValue("userSession", new UserSession() /*default_values*/), new UserSession() /*prototype of class with methods*/);
        this._bsUserSession$.next(userSession);
    }
    get bsUserSession$() {
        return this._bsUserSession$;
    }
    setUserSession(userSession) {
        this.storeSessionKeyValue("userSession", userSession);
        this._bsUserSession$.next(userSession);
    }
}
UserSessionService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: UserSessionService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
UserSessionService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: UserSessionService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.1.0", ngImport: i0, type: UserSessionService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class GenericMemCrudService {
    constructor() {
        this.objectsMap = new Map(); //must be set by subclass
    }
    idFromObj(obj) {
        return obj["code"];
    }
    notNullObj(obj) {
        return obj;
    }
    postEntityObject$(obj) {
        this.objectsMap.set(this.idFromObj(obj), obj);
        return of(obj);
    }
    putEntityObject$(obj) {
        this.objectsMap.set(this.idFromObj(obj), obj);
        return of(obj);
    }
    getEntityObjectById$(id, requiredRole = null) {
        let obj = this.objectsMap.get(id);
        return of(this.notNullObj(obj));
    }
    getAllObjects$(requiredRole = null) {
        let tab = [];
        for (let obj of this.objectsMap.values()) {
            tab.push(obj);
        }
        return of(tab);
    }
    findObjectsFromCriteria$(criteriaEndUrl, requiredRole = null) {
        return this.getAllObjects$();
    }
    deleteEntityObjectServerSide$(id) {
        this.objectsMap.delete(id);
        return of({});
    }
}

class GenericRestCrudService {
    constructor(http) {
        this.http = http;
        this.publicBaseUrl = null; //must be set by subclass
        this.privateBaseUrl = null; //avec ng serve --proxy-config proxy.conf.json
        this.settingPublicAndPrivateBaseUrl();
    }
    postEntityObject$(obj) {
        let url = this.privateBaseUrl;
        return this.http.post(url, obj);
    }
    putEntityObject$(obj) {
        let url = this.privateBaseUrl;
        return this.http.put(url, obj);
    }
    getEntityObjectById$(id, requiredRole = null) {
        let url;
        if (requiredRole == null) {
            url = this.publicBaseUrl + "/" + id;
        }
        else {
            url = this.privateBaseUrl + "/" + id; //encore améliorable
        }
        return this.http.get(url);
    }
    getAllObjects$(requiredRole = null) {
        let url;
        if (requiredRole == null) {
            url = this.publicBaseUrl;
        }
        else {
            url = this.privateBaseUrl; //encore améliorable
        }
        return this.http.get(url);
    }
    findObjectsFromCriteria$(criteriaEndUrl, requiredRole = null) {
        let url;
        if (requiredRole == null) {
            url = this.publicBaseUrl + criteriaEndUrl;
        }
        else {
            url = this.privateBaseUrl + criteriaEndUrl; //encore améliorable
        }
        return this.http.get(url);
    }
    deleteEntityObjectServerSide$(id) {
        //console.log("deleting EntityObject of id = " + id );
        let url = this.privateBaseUrl + "/" + id;
        //console.log("deleteUrl= " + url );
        return this.http.delete(url);
    }
}
class GenericRestCrudServiceWithUpload extends GenericRestCrudService {
    constructor(http) {
        super(http);
        this.uploadBaseUrl = ""; //must be set by subclass
        this.settingUploadBaseUrl();
    }
    uploadFormData$(formData) {
        return this.http.post(this.uploadBaseUrl, formData);
    }
}

/*
 * Public API Surface of my-ngx-commons
 */

/**
 * Generated bundle index. Do not edit.
 */

export { D2fNgxCommonsComponent, D2fNgxCommonsModule, D2fNgxCommonsService, GenericMemCrudService, GenericRestCrudService, GenericRestCrudServiceWithUpload, UserSession, UserSessionService, cloneObjectWithoutMethod, copyObjectProperties, messageFromError, objectWithMethodsOfProto };
//# sourceMappingURL=d2f-ngx-commons.mjs.map
