import { Observable } from "rxjs";
import { GenericCrudService } from "./generic-crud-service";
export declare abstract class GenericMemCrudService<T> implements GenericCrudService<T> {
    protected objectsMap: Map<any, T>;
    abstract initMap(): void;
    idFromObj(obj: any): any;
    notNullObj(obj: T | null | undefined): T;
    constructor();
    postEntityObject$(obj: T): Observable<T>;
    putEntityObject$(obj: T): Observable<T>;
    getEntityObjectById$(id: any, requiredRole?: string | null): Observable<T>;
    getAllObjects$(requiredRole?: string | null): Observable<T[]>;
    findObjectsFromCriteria$(criteriaEndUrl: string, requiredRole?: string | null): Observable<T[]>;
    deleteEntityObjectServerSide$(id: any): Observable<any>;
}
