import { HttpClient } from '@angular/common/http';
import { Observable } from "rxjs";
import { GenericCrudService } from './generic-crud-service';
export declare abstract class GenericRestCrudService<T> implements GenericCrudService<T> {
    protected http: HttpClient;
    protected publicBaseUrl: string | null;
    protected privateBaseUrl: string | null;
    abstract settingPublicAndPrivateBaseUrl(): void;
    constructor(http: HttpClient);
    postEntityObject$(obj: T): Observable<T>;
    putEntityObject$(obj: T): Observable<T>;
    getEntityObjectById$(id: any, requiredRole?: string | null): Observable<T>;
    getAllObjects$(requiredRole?: string | null): Observable<T[]>;
    findObjectsFromCriteria$(criteriaEndUrl: string, requiredRole?: string | null): Observable<T[]>;
    deleteEntityObjectServerSide$(id: any): Observable<any>;
}
export declare abstract class GenericRestCrudServiceWithUpload<T> extends GenericRestCrudService<T> {
    protected uploadBaseUrl: string;
    constructor(http: HttpClient);
    abstract settingUploadBaseUrl(): void;
    uploadFormData$(formData: FormData): Observable<T>;
}
